#!/usr/bin/perl

#!perl



use strict;
$| = 1;

use settings;

my $filename     = settings->filename;;
my $tempfile     = settings->tempfile;
my $redirectpage = settings->redirectpage;

&create_bases;

my $HEADER_SENT;
my %FORM_DATA;
&cgi_input ;

&unsubscribe ;


# ----------------------------------------------------------------------
sub cgi_input  {

#
# get CGI values (simply method)
#

my $whichmethod = $ENV{'REQUEST_METHOD'};

my $forminfo;

if($whichmethod eq 'GET'){ 
    $forminfo = $ENV{'QUERY_STRING'};
  }else{
    $forminfo = <STDIN>; 
  } 

my @key_value_pairs = split(/&/,$forminfo); 
foreach my $pair (@key_value_pairs){

    my ($key,$value) = split(/=/,$pair);
     $value =~ s/\+/ /g; 
     $value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
     $value =~ s/'/\\'/g;
     $FORM_DATA{$key} = $value;
  }
} 
# ----------------------------------------------------------------------
sub unsubscribe {

my $rem_email = $FORM_DATA{'email'};

my $file_ref = &read_file($filename); 


  open(OUT, ">$tempfile") || &print_response("cant open file, $!"); 

  foreach my $line (@{$file_ref})
  {
      my %rec   = %{&getrecord($line)};
      my $email = $rec{'email'};
      if ($email ne $rem_email)
      {
        print OUT $line;
      }
  }

  close(OUT);

    rename($tempfile, $filename);



&print_redirection($redirectpage);

}

# ----------------------------------------------------------------------
sub create_bases {
  unless ( -e $filename )  { &create_file($filename) };
}
# ----------------------------------------------------------------------

sub create_file {

  my($fname) = @_;

  open(OUT, ">$fname") || &print_response("cant open file, $!"); 
  close(OUT);
}

# ----------------------------------------------------------------------

sub print_redirection {
#
# redirects the browser to the desired URL, if possible
#
    my( $location ) = @_;

    print qq|Location: $location\n\n|;
    $HEADER_SENT = 'yes';

    return undef;
}

# ----------------------------------------------------------------------
sub getrecord {
#
# do hash from record
#

my ($line) = @_;

  $line =~ s/\n//gs;
  my @vars = split( /\|/, $line );

  my %rec;

  $rec{'type'} = @vars[0];
  $rec{'name'} = @vars[1];
  $rec{'email'} = @vars[2];

  return \%rec;
}
# ----------------------------------------------------------------------
sub read_file {

    my($file) = @_;

    my @lines;

    open( FILE, "<$file" ) || die( "opening $filename, $!" );
    my $line;
    while(<FILE>)
    {
      $line = $_;
      push(@lines, $line);
    }

    close( FILE );

   return \@lines;
}
# ----------------------------------------------------------------------
